<template>
    <dialog id="my_modal_1" class="modal" :open="open">
        <div class="modal-box">
            <h3 class="font-bold text-lg">{{ title }}</h3>
            <p v-if="subTitle" class="py-4">{{ subTitle }}</p>
            <div class="modal-action flex flex-col">
                <form method="dialog" @submit.prevent="submitValue">
                    <input ref="inputRef" type="text" v-model="inputValue" id="" :placeholder="placeholder"
                        class="input input-bordered input-primary w-full flex-1">
                    <!-- if there is a button in form, it will close the modal -->
                    <div class="flex justify-end mt-5">
                        <button @click="$emit('close')" class="btn mr-4">Close</button>
                        <button type="submit" class="btn btn-primary">Aceptar</button>
                    </div>
                </form>
            </div>
        </div>
    </dialog>

    <div v-if="open" class="modal-backgrop fixed top-0 left-0 z-10 bg-black opacity-40 w-screen h-screen"></div>
</template>

<script lang="ts" setup>
import { ref, watch } from 'vue';

interface Props {
    open: boolean
    placeholder?: string
    title: string
    subTitle?: string
}

const props = withDefaults(defineProps<Props>(), {
    placeholder: 'Ingrese un valor'
})

const emits = defineEmits<{
    close: [void],
    value: [test: string]
}>()

const inputValue = ref('')
const inputRef = ref<HTMLInputElement | null>(null)

watch(props, ({ open }) => {
    if (open) {
        inputRef.value?.focus()
    }
})

const submitValue = () => {
    if (!inputValue.value) {
        // foco en el input
        inputRef.value?.focus()
        return;
    }

    emits('value', inputValue.value.trim())
    emits('close')

    inputValue.value = ''
}



</script>